DCMTK: DJDecoderLossless Class Reference

DCMTK Version 3.7.0 OFFIS DICOM Toolkit

Loading...
Searching...
No Matches
Public Member Functions | Private Member Functions | List of all members
DJDecoderLossless Class Reference

Decoder class for JPEG Lossless (8/12/16-bit). More...

Inheritance diagram for DJDecoderLossless:

## Public Member Functions
| DJDecoderLossless ()
| default constructor
virtual | ~DJDecoderLossless ()
| destructor
virtual E_TransferSyntax | supportedTransferSyntax () const
| returns the transfer syntax that this particular codec is able to encode and decode.
virtual OFBool | isLosslessProcess () const
| returns true if the transfer syntax supported by this codec is lossless.
Public Member Functions inherited from DJCodecDecoder
| DJCodecDecoder ()
| default constructor
virtual | ~DJCodecDecoder ()
| destructor
virtual OFCondition | decode (const DcmRepresentationParameter *fromRepParam, DcmPixelSequence *pixSeq, DcmPolymorphOBOW &uncompressedPixelData, const DcmCodecParameter *cp, const DcmStack &objStack, OFBool &removeOldRep) const
| decompresses the given pixel sequence and stores the result in the given uncompressedPixelData element.
virtual OFCondition | decodeFrame (const DcmRepresentationParameter *fromParam, DcmPixelSequence *fromPixSeq, const DcmCodecParameter *cp, DcmItem *dataset, Uint32 frameNo, Uint32 &startFragment, void *buffer, Uint32 bufSize, OFString &decompressedColorModel) const
| decompresses a single frame from the given pixel sequence and stores the result in the given buffer.
virtual OFCondition | encode (const Uint16 *pixelData, const Uint32 length, const DcmRepresentationParameter *toRepParam, DcmPixelSequence *&pixSeq, const DcmCodecParameter *cp, DcmStack &objStack, OFBool &removeOldRep) const
| compresses the given uncompressed DICOM image and stores the result in the given pixSeq element.
virtual OFCondition | encode (const E_TransferSyntax fromRepType, const DcmRepresentationParameter *fromRepParam, DcmPixelSequence *fromPixSeq, const DcmRepresentationParameter *toRepParam, DcmPixelSequence *&toPixSeq, const DcmCodecParameter *cp, DcmStack &objStack, OFBool &removeOldRep) const
| transcodes (re-compresses) the given compressed DICOM image and stores the result in the given toPixSeq element.
virtual OFBool | canChangeCoding (const E_TransferSyntax oldRepType, const E_TransferSyntax newRepType) const
| checks if this codec is able to convert from the given current transfer syntax to the given new transfer syntax
virtual Uint16 | decodedBitsAllocated (Uint16 bitsAllocated, Uint16 bitsStored) const
| determines the effective value of BitsAllocated that a dataset will have after decompression of an image with the given values for bitsAllocated and bitsStored.
virtual OFCondition | determineDecompressedColorModel (const DcmRepresentationParameter *fromParam, DcmPixelSequence *fromPixSeq, const DcmCodecParameter *cp, DcmItem *dataset, OFString &decompressedColorModel) const
| determine color model of the decompressed image
Public Member Functions inherited from DcmCodec
| DcmCodec ()
| default constructor
virtual | ~DcmCodec ()
| destructor

## Private Member Functions
virtual DJDecoder * | createDecoderInstance (const DcmRepresentationParameter *toRepParam, const DJCodecParameter *cp, Uint8 bitsPerSample, OFBool isYBR) const
| creates an instance of the compression library to be used for decoding.

## Additional Inherited Members
Static Public Member Functions inherited from DcmCodec
static OFCondition | insertStringIfMissing (DcmItem *dataset, const DcmTagKey &tag, const char *val)
| helper function that inserts a string attribute with a given value into a dataset if missing in the dataset.
static OFCondition | convertToSecondaryCapture (DcmItem *dataset)
| helper function that converts a dataset containing a DICOM image into a valid (standard extended) Secondary Capture object by inserting all attributes that are type 1/2 in Secondary Capture and missing in the source dataset.
static OFCondition | newInstance (DcmItem *dataset, const char *purposeOfReferenceCodingScheme=NULL, const char *purposeOfReferenceCodeValue=NULL, const char *purposeOfReferenceCodeMeaning=NULL)
| create new SOP Instance UID and Source Image Sequence referencing the old SOP instance (if present)
static OFCondition | updateImageType (DcmItem *dataset)
| update value of the Image Type element (if needed).
static OFCondition | insertCodeSequence (DcmItem *dataset, const DcmTagKey &tagKey, const char *codingSchemeDesignator, const char *codeValue, const char *codeMeaning)
| insert code sequence into the given dataset
static OFCondition | determineStartFragment (Uint32 frameNo, Sint32 numberOfFrames, DcmPixelSequence *fromPixSeq, Uint32 &currentItem)
| determine the index number (starting with zero) of the compressed pixel data fragment corresponding to the given frame (also starting with zero)

## Detailed Description

Decoder class for JPEG Lossless (8/12/16-bit).

## Member Function Documentation

## ◆ createDecoderInstance()

virtual DJDecoder * DJDecoderLossless::createDecoderInstance | ( | const DcmRepresentationParameter * | toRepParam,
|  | const DJCodecParameter * | cp,
|  | Uint8 | bitsPerSample,
|  | OFBool | isYBR ) const
| privatevirtual

creates an instance of the compression library to be used for decoding.

Parameters

  toRepParam | representation parameter passed to decode()
  cp | codec parameter passed to decode()
  bitsPerSample | bits per sample for the image data
  isYBR | flag indicating whether DICOM photometric interpretation is YCbCr

Returns
  pointer to newly allocated decoder object

Implements DJCodecDecoder.

## ◆ isLosslessProcess()

virtual OFBool DJDecoderLossless::isLosslessProcess | ( |  | ) | const
| virtual

returns true if the transfer syntax supported by this codec is lossless.

Returns
  lossless flag

Implements DJCodecDecoder.

## ◆ supportedTransferSyntax()

virtual E_TransferSyntax DJDecoderLossless::supportedTransferSyntax | ( |  | ) | const
| virtual

returns the transfer syntax that this particular codec is able to encode and decode.

Returns
  supported transfer syntax

Implements DJCodecDecoder.

The documentation for this class was generated from the following file:

- dcmjpeg/include/dcmtk/dcmjpeg/djdeclol.h

Generated on for DCMTK Version 3.7.0 by Doxygen 1.16.1